<?php

namespace app\admin\controller;

use app\common\model\ai\Config;

class Aiconfig extends Botbase
{
    /**
     * @var Config
     */
    protected $model;
    /**
     * @var array
     */
    private $tabList;

    public function initialize()
    {
        parent::initialize(); // TODO: Change the autogenerated stub
        $this->model = new Config();
        $this->tabList = [

        ];
    }

    /**
     * 设置
     * @return mixed
     * @throws \think\Exception
     * @author: fudaoji<fdj@kuryun.cn>
     */
    public function index(){
        $settings = $this->model->getConf(['bot_id' => $this->bot['id']]);
        if(!empty($settings['wxids'])){
            $settings['wxids'] = explode(',', $settings['wxids']);
        }

        $builder = new FormBuilder();
        $builder->setPostUrl(url('savePost'))
            ->addFormItem('basic_legend', 'legend', '基础配置','基础配置' )
            ->addFormItem('id', 'hidden', 'id', 'id')
            ->addFormItem('switch', 'radio', '开启', '是否开启', [1=>'是', 0 => '否'])
            ->addFormItem('wxids', 'chosen_multi', '作用对象', '指定的作用对象才会生效', $this->getMembers(), 'required')
            ->addFormItem('weixin_legend', 'legend', '微信智能对话','微信智能对话' )
            ->addFormItem('wx_appid', 'text', 'Appid', '微信智能对话的Appid')
            ->addFormItem('wx_token', 'text', 'Token', '微信智能对话的Token')
            ->addFormItem('wx_encoding_aes_key', 'text', 'EncodingAesKey', '微信智能对话的EncodingAesKey')
            ->setFormData($settings);
        return $builder->show();
    }

    public function savePost($jump_to = '/undefined', $data = [])
    {
        $jump_to = url('index');
        $post_data = input('post.');
        unset($post_data['__token__']);
        foreach ($post_data as $k => $v){
            if($config = $this->model->getOneByMap(['bot_id' => $this->bot['id'], 'key' => $k],  true, true)){
                $this->model->updateOne(['id' => $config['id'], 'value' => $v]);
            }else{
                $this->model->addOne([
                    'admin_id' => $this->adminInfo['id'],
                    'bot_id' => $this->bot['id'],
                    'key' => $k,
                    'value'=> $v
                ]);
            }
            $this->model->getConf(['bot_id' => $this->bot['id']], $k, true);
        }
        $this->success('数据保存成功', $jump_to);
    }
}